diff --git a/target/linux/ar71xx/config-4.1 b/target/linux/ar71xx/config-4.1
index c01ec6e..f42a65d 100644
--- a/target/linux/ar71xx/config-4.1
+++ b/target/linux/ar71xx/config-4.1
@@ -51,6 +51,7 @@ CONFIG_ATH79_MACH_CAP324=y
 CONFIG_ATH79_MACH_CAP4200AG=y
 CONFIG_ATH79_MACH_CARAMBOLA2=y
 CONFIG_ATH79_MACH_CPE510=y
+CONFIG_ATH79_MACH_CR3000=y
 CONFIG_ATH79_MACH_DB120=y
 CONFIG_ATH79_MACH_DGL_5500_A1=y
 CONFIG_ATH79_MACH_DHP_1565_A1=y
diff --git a/target/linux/ar71xx/patches-4.1/815-MIPS-ath79-add-cr3000-support.patch b/target/linux/ar71xx/patches-4.1/815-MIPS-ath79-add-cr3000-support.patch
new file mode 100644
index 0000000..06b1fbc
--- /dev/null
+++ b/target/linux/ar71xx/patches-4.1/815-MIPS-ath79-add-cr3000-support.patch
@@ -0,0 +1,211 @@
+Index: linux-4.1.3/arch/mips/ath79/Kconfig
+===================================================================
+--- linux-4.1.3.orig/arch/mips/ath79/Kconfig
++++ linux-4.1.3/arch/mips/ath79/Kconfig
+@@ -906,6 +906,16 @@ config ATH79_MACH_CAP324
+ 	select ATH79_DEV_M25P80
+ 	select ATH79_DEV_WMAC
+ 
++config ATH79_MACH_CR3000
++	bool "PowerCloud Systems CR3000 support"
++	select SOC_AR934X
++	select ATH79_DEV_AP9X_PCI if PCI
++	select ATH79_DEV_ETH
++	select ATH79_DEV_GPIO_BUTTONS
++	select ATH79_DEV_LEDS_GPIO
++	select ATH79_DEV_M25P80
++	select ATH79_DEV_WMAC
++
+ config ATH79_MACH_EAP7660D
+ 	bool "Senao EAP7660D support"
+ 	select SOC_AR71XX
+Index: linux-4.1.3/arch/mips/ath79/Makefile
+===================================================================
+--- linux-4.1.3.orig/arch/mips/ath79/Makefile
++++ linux-4.1.3/arch/mips/ath79/Makefile
+@@ -59,6 +59,7 @@ obj-$(CONFIG_ATH79_MACH_BHU_BXU2000N2_A)
+ obj-$(CONFIG_ATH79_MACH_CAP324)		+= mach-cap324.o
+ obj-$(CONFIG_ATH79_MACH_CAP4200AG)	+= mach-cap4200ag.o
+ obj-$(CONFIG_ATH79_MACH_CPE510)		+= mach-cpe510.o
++obj-$(CONFIG_ATH79_MACH_CR3000)		+= mach-cr3000.o
+ obj-$(CONFIG_ATH79_MACH_DB120)		+= mach-db120.o
+ obj-$(CONFIG_ATH79_MACH_DLAN_PRO_500_WP)	+= mach-dlan-pro-500-wp.o
+ obj-$(CONFIG_ATH79_MACH_DLAN_PRO_1200_AC)	+= mach-dlan-pro-1200-ac.o
+Index: linux-4.1.3/arch/mips/ath79/mach-cr3000.c
+===================================================================
+--- /dev/null
++++ linux-4.1.3/arch/mips/ath79/mach-cr3000.c
+@@ -0,0 +1,161 @@
++/*
++ * PowerCloud Systems CR3000 support
++ *
++ * Copyright (c) 2011 Qualcomm Atheros
++ * Copyright (c) 2011-2012 Gabor Juhos <juhosg@openwrt.org>
++ * Copyright (c) 2012-2013 PowerCloud Systems
++ * Copyright (c) 2015 Daniel Dickinson <openwrt@daniel.thecshore.com>
++ *
++ * Permission to use, copy, modify, and/or distribute this software for any
++ * purpose with or without fee is hereby granted, provided that the above
++ * copyright notice and this permission notice appear in all copies.
++ *
++ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
++ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
++ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
++ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
++ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
++ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
++ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
++ *
++ */
++
++#include <linux/gpio.h>
++#include <linux/pci.h>
++#include <linux/phy.h>
++#include <linux/platform_device.h>
++#include <linux/ath9k_platform.h>
++#include <linux/ar8216_platform.h>
++
++#include <asm/mach-ath79/ar71xx_regs.h>
++#include <asm/mach-ath79/ath79.h>
++
++#include "common.h"
++#include "dev-ap9x-pci.h"
++#include "dev-eth.h"
++#include "dev-gpio-buttons.h"
++#include "dev-leds-gpio.h"
++#include "dev-m25p80.h"
++#include "dev-spi.h"
++#include "dev-wmac.h"
++#include "machtypes.h"
++
++#define CR3000_GPIO_LED_WLAN_2G		13
++#define CR3000_GPIO_LED_POWER_AMBER	15
++#define CR3000_GPIO_LED_WAN             18
++#define CR3000_GPIO_LED_LAN1            19
++#define CR3000_GPIO_LED_LAN2            20
++#define CR3000_GPIO_LED_LAN3            21
++#define CR3000_GPIO_LED_LAN4            22
++
++#define CR3000_GPIO_BTN_WPS		16
++#define CR3000_GPIO_BTN_RESET		17
++
++#define CR3000_KEYS_POLL_INTERVAL	20	/* msecs */
++#define CR3000_KEYS_DEBOUNCE_INTERVAL	(3 * CR3000_KEYS_POLL_INTERVAL)
++
++#define CR3000_MAC0_OFFSET		0
++#define CR3000_MAC1_OFFSET		6
++#define CR3000_WMAC_CALDATA_OFFSET	0x1000
++#define CR3000_WMAC_MAC_OFFSET	        0x1002
++#define CR3000_PCIE_CALDATA_OFFSET	0x5000
++
++static struct gpio_led cr3000_leds_gpio[] __initdata = {
++	{
++		.name		= "pcs:amber:power",
++		.gpio		= CR3000_GPIO_LED_POWER_AMBER,
++		.active_low	= 1,
++	},
++	{
++		.name		= "pcs:blue:wlan",
++		.gpio		= CR3000_GPIO_LED_WLAN_2G,
++		.active_low	= 1,
++	},
++	{
++		.name		= "cr3000:blue:wan",
++		.gpio		= CR3000_GPIO_LED_WAN,
++		.active_low	= 1,
++	},
++	{
++		.name		= "cr3000:blue:lan1",
++		.gpio		= CR3000_GPIO_LED_LAN1,
++		.active_low	= 1,
++	},
++	{
++		.name		= "cr3000:blue:lan2",
++		.gpio		= CR3000_GPIO_LED_LAN2,
++		.active_low	= 1,
++	},
++	{
++		.name		= "cr3000:blue:lan3",
++		.gpio		= CR3000_GPIO_LED_LAN3,
++		.active_low	= 1,
++	},
++	{
++		.name		= "cr3000:blue:lan4",
++		.gpio		= CR3000_GPIO_LED_LAN4,
++		.active_low	= 1,
++	},
++};
++
++static struct gpio_keys_button cr3000_gpio_keys[] __initdata = {
++	{
++		.desc		= "WPS button",
++		.type		= EV_KEY,
++		.code		= KEY_WPS_BUTTON,
++		.debounce_interval = CR3000_KEYS_DEBOUNCE_INTERVAL,
++		.gpio		= CR3000_GPIO_BTN_WPS,
++		.active_low	= 1,
++	},
++	{
++		.desc		= "Reset button",
++		.type		= EV_KEY,
++		.code		= KEY_WPS_BUTTON,
++		.debounce_interval = CR3000_KEYS_DEBOUNCE_INTERVAL,
++		.gpio		= CR3000_GPIO_BTN_RESET,
++		.active_low	= 1,
++	},
++};
++
++static void __init cr3000_setup(void)
++{
++	u8 *art = (u8 *) KSEG1ADDR(0x1fff0000);
++
++	ath79_register_m25p80(NULL);
++
++	ath79_register_leds_gpio(-1, ARRAY_SIZE(cr3000_leds_gpio),
++				 cr3000_leds_gpio);
++
++	ath79_register_gpio_keys_polled(-1, CR3000_KEYS_POLL_INTERVAL,
++					ARRAY_SIZE(cr3000_gpio_keys),
++					cr3000_gpio_keys);
++
++	/* WLAN 2GHz onboard */
++	ath79_register_wmac(art + CR3000_WMAC_CALDATA_OFFSET, art + CR3000_WMAC_MAC_OFFSET);
++	
++	ath79_setup_ar934x_eth_cfg(AR934X_ETH_CFG_RGMII_GMAC0 |
++				   AR934X_ETH_CFG_SW_ONLY_MODE);
++
++	ath79_register_mdio(1, 0x0);
++
++	/* WAN Fast Ethernet interface */
++	ath79_init_mac(ath79_eth0_data.mac_addr, art + CR3000_MAC0_OFFSET, 0);
++
++       ath79_switch_data.phy4_mii_en = 1;
++       ath79_switch_data.phy_poll_mask = BIT(0);
++	ath79_eth0_data.phy_if_mode = PHY_INTERFACE_MODE_MII;
++	ath79_eth0_data.phy_mask = BIT(0);
++	ath79_eth0_data.mii_bus_dev = &ath79_mdio0_device.dev;
++	ath79_register_eth(0);
++
++	/* Lan 4-port switch */
++	ath79_init_mac(ath79_eth1_data.mac_addr, art + CR3000_MAC1_OFFSET, 0);
++
++	ath79_eth1_data.phy_if_mode = PHY_INTERFACE_MODE_GMII;
++	ath79_eth1_data.speed = SPEED_1000;
++	ath79_eth1_data.duplex = DUPLEX_FULL;
++	ath79_register_eth(1);
++}
++
++MIPS_MACHINE(ATH79_MACH_CR3000, "CR3000", "PowerCloud CR3000",
++	     cr3000_setup);
+Index: linux-4.1.3/arch/mips/ath79/machtypes.h
+===================================================================
+--- linux-4.1.3.orig/arch/mips/ath79/machtypes.h
++++ linux-4.1.3/arch/mips/ath79/machtypes.h
+@@ -43,6 +43,7 @@ enum ath79_mach_type {
+ 	ATH79_MACH_CAP4200AG,		/* Senao CAP4200AG */
+ 	ATH79_MACH_CARAMBOLA2,		/* 8devices Carambola2 */
+ 	ATH79_MACH_CPE510,		/* TP-LINK CPE510 */
++	ATH79_MACH_CR3000,		/* PowerCloud Systems CR3000 */
+ 	ATH79_MACH_DB120,		/* Atheros DB120 reference board */
+ 	ATH79_MACH_PB44,		/* Atheros PB44 reference board */
+ 	ATH79_MACH_DGL_5500_A1,		/* D-link DGL-5500 rev. A1 */