diff --git a/target/linux/ar71xx/generic/profiles/pcs.mk b/target/linux/ar71xx/generic/profiles/pcs.mk
index ec712aa..e912d9d 100644
--- a/target/linux/ar71xx/generic/profiles/pcs.mk
+++ b/target/linux/ar71xx/generic/profiles/pcs.mk
@@ -108,3 +108,40 @@ endef
 
 $(eval $(call Profile,CR3000NOCLOUD))
 
+define Profile/CR5000
+	NAME:=PowerCloud CR5000 Cloud Router
+	PACKAGES:=uboot-envtools kmod-usb-core kmod-usb2 kmod-usb-ohci kmod-ledtrig-usbdev
+endef
+
+define Profile/CR5000/Description
+	Package set optimized for the PowerCloud Systems CR5000 Cloud Router
+
+	The CR5000 is a dual-band 802.11n wireless router with 8MB flash,
+	64MB RAM, (unused on stock firmware) USB 2.0 port and five port
+	gigabit ethernet switch.  The CR5000 was sold as hardware for
+	the Skydog cloud-managed router service.
+endef
+
+$(eval $(call Profile,CR5000))
+
+define Profile/CR5000NOCLOUD
+	NAME:=PowerCloud CR5000 Without Cloud
+	PACKAGES:=uboot-envtools kmod-usb-core kmod-usb2 kmod-usb-ohci kmod-ledtrig-usbdev
+endef
+
+define Profile/CR5000NOCLOUD/Description
+	Package set optimized for the PowerCloud Systems CR5000 Without Cloud
+
+	The CR5000 is a dual-band 802.11n wireless router with 8MB flash,
+	64MB RAM, (unused on stock firmware) USB 2.0 port and five port
+	gigabit ethernet switch.  The CR5000 was sold as hardware for
+	the Skydog cloud-managed router service.
+
+	WARNING: Will remove certificates used by cloud firmware
+	After flashing this firmware you will not be able to
+	return the device to cloud operation.
+        The advantage is reclaiming flash used for the certificates.
+endef
+
+$(eval $(call Profile,CR5000NOCLOUD))
+
diff --git a/target/linux/ar71xx/image/Makefile b/target/linux/ar71xx/image/Makefile
index 5e1b432..bb21daf 100644
--- a/target/linux/ar71xx/image/Makefile
+++ b/target/linux/ar71xx/image/Makefile
@@ -1204,6 +1204,8 @@ cap4200ag_mtdlayout=mtdparts=spi0.0:256k(u-boot),64k(u-boot-env),320k(custom)ro,
 cpe510_mtdlayout=mtdparts=spi0.0:128k(u-boot)ro,64k(pation-table)ro,64k(product-info)ro,1536k(kernel),6144k(rootfs),192k(config)ro,64k(ART)ro,7680k@0x40000(firmware)
 cr3000_mtdlayout=mtdparts=spi0.0:256k(u-boot)ro,64k(u-boot-env)ro,1408k(kernel),5696k(rootfs),640k(certs),64k(nvram),64k(art)ro,7104k@0x50000(firmware)
 cr3000nocloud_mtdlayout=mtdparts=spi0.0:256k(u-boot)ro,64k(u-boot-env)ro,1408k(kernel),6400k(rootfs),64k(art)ro,7808k@0x50000(firmware)
+cr5000_mtdlayout=mtdparts=spi0.0:256k(u-boot)ro,64k(u-boot-env)ro,1408k(kernel),5760k(rootfs),640k(certs),64k(nvram),64k(art)ro,7104k@0x50000(firmware)
+cr5000nocloud_mtdlayout=mtdparts=spi0.0:256k(u-boot)ro,64k(u-boot-env)ro,1408k(kernel),6400k(rootfs),64k(art)ro,7808k@0x50000(firmware)
 eap300v2_mtdlayout=mtdparts=spi0.0:256k(u-boot)ro,64k(u-boot-env),320k(custom),13632k(firmware),2048k(failsafe),64k(art)ro
 db120_mtdlayout=mtdparts=spi0.0:256k(u-boot)ro,64k(u-boot-env)ro,6336k(rootfs),1408k(kernel),64k(nvram),64k(art)ro,7744k@0x50000(firmware)
 dgl_5500_mtdlayout=mtdparts=spi0.0:192k(u-boot)ro,64k(nvram)ro,15296k(firmware),192k(lang)ro,512k(my-dlink)ro,64k(mac)ro,64k(art)ro
@@ -2084,6 +2086,8 @@ $(eval $(call SingleProfile,AthLzma,64k,CAP324NOCLOUD,cap324nocloud,CAP324,ttyS0
 $(eval $(call SingleProfile,AthLzma,64k,CAP4200AG,cap4200ag,CAP4200AG,ttyS0,115200,$$(cap4200ag_mtdlayout),KRuImage))
 $(eval $(call SingleProfile,AthLzma,64k,CR3000,cr3000,CR3000,ttyS0,115200,$$(cr3000_mtdlayout),KRuImage))
 $(eval $(call SingleProfile,AthLzma,64k,CR3000NOCLOUD,cr3000nocloud,CR3000,ttyS0,115200,$$(cr3000nocloud_mtdlayout),KRuImage))
+$(eval $(call SingleProfile,AthLzma,64k,CR5000,cr5000,CR5000,ttyS0,115200,$$(cr5000_mtdlayout),KRuImage))
+$(eval $(call SingleProfile,AthLzma,64k,CR5000NOCLOUD,cr5000nocloud,CR5000,ttyS0,115200,$$(cr5000nocloud_mtdlayout),KRuImage))
 $(eval $(call SingleProfile,AthLzma,64k,DB120,db120,DB120,ttyS0,115200,$$(db120_mtdlayout),RKuImage))
 $(eval $(call SingleProfile,AthLzma,64k,DRAGINO2,dragino2,DRAGINO2,ttyATH0,115200,$$(dragino2_mtdlayout),KRuImage,65536))
 $(eval $(call SingleProfile,AthLzma,64k,EWDORINAP,ew-dorin,EW-DORIN,ttyATH0,115200,$$(ew-dorin_mtdlayout_4M),KRuImage,65536))